--- src/org/apache/axis/client/Service.java.old	2007-02-15 17:31:13.000000000 +0100
+++ src/org/apache/axis/client/Service.java	2007-02-16 15:52:26.000000000 +0100
@@ -118,13 +118,12 @@
     private HandlerRegistryImpl registry = new HandlerRegistryImpl();
     private Parser wsdlParser = null;
 
-    /**
-     * Thread local storage used for storing the last call object
-     */
-    private static ThreadLocal previousCall = new ThreadLocal();
     private static HashMap cachedWSDL = new HashMap();
     private static boolean cachingWSDL = true;
 
+	// the last call object
+	protected Call _call = null;
+
     /**
      * A Hashtable mapping addresses (URLs) to Transports (objects)
      */
@@ -563,9 +562,8 @@
      * @throws ServiceException If there's an error
      */
     public javax.xml.rpc.Call createCall() throws ServiceException {
-        Call call = new org.apache.axis.client.Call(this);
-        previousCall.set(call);
-        return call;
+        _call = new org.apache.axis.client.Call(this);
+        return _call;
     }
 
     /**
@@ -826,8 +824,7 @@
     }
 
     public Call getCall() throws ServiceException {
-        Call call = (Call) previousCall.get();
-        return call;
+        return _call;
     }
 
     /**
--- ./src/org/apache/axis/client/Stub.java.old	2007-02-16 15:25:42.000000000 +0100
+++ ./src/org/apache/axis/client/Stub.java	2007-02-16 15:30:47.000000000 +0100
@@ -103,6 +103,10 @@
     // a synchronized block in the generated stub code.
     private boolean firstCall = true;
 
+    // The last call object
+    protected Call _call = null;
+
+
     /**
      * Is this the first time the type mappings are being registered?
      */
@@ -405,6 +409,26 @@
     }  
 
     /**
+     * Creates a call from the service.
+     * @return
+     */
+    public Call _createCall() throws ServiceException {
+       _call = (Call) service.createCall();
+
+	// TODO: There is a lot of code in the generated stubs that
+        // can be moved here.
+        return _call;
+    }
+
+    /**
+     * Returns last Call object associated with this stub.
+     */
+    public Call _getCall() {
+        return _call;
+    }
+				
+
+    /**
      * Helper method for updating headers from the response.
      *
      * Deprecated, since response headers should not be
